/////////////////////////////////////////////////////////////////////////////
// GbVideo.h : Gamebios Video
/////////////////////////////////////////////////////////////////////////////
#ifndef __GBVIDEO_H__
#define __GBVIDEO_H__
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "Gamebios.h"

/////////////////////////////////////////////////////////////////////////////
// Prototype

#define GBVIDEODEVICE_WINDOWMODE			(1 << 1)
#define GBVIDEODEVICE_GAMMACONTROL			(1 << 2)
#define GBVIDEODEVICE_COLORCONTROL			(1 << 3)
#define GBVIDEODEVICE_3DDEVICE				(1 << 4)

#define GBVIDEO_FRONTBUFFER					(1)
#define GBVIDEO_BACKBUFFER					(2)

#define GBVIDEOSHOWMODE_FLIP				(1 << 1)
#define GBVIDEOSHOWMODE_BLT					(1 << 2)

#define GBVIDEORGB(r, g, b)					RGB(r, g, b)

typedef COLORREF GBVIDEOCOLOR;

typedef struct {
	CHAR	pszName[256];
	CHAR	pszLocalName[256];
	DWORD	dwFlags;
} *LPGBVIDEODEVICEINFO, GBVIDEODEVICEINFO;

typedef struct {
	INT		nDevice;
	DWORD	dwFlags;
} *LPGBVIDEOSTARTUPDEVICEINFO, GBVIDEOSTARTUPDEVICEINFO;

typedef struct {
	CHAR	pszName[256];
	INT		nWidth;
	INT		nHeight;
	INT		nBpp;
} *LPGBVIDEOMODEINFO, GBVIDEOMODEINFO;

GBEXPORT BOOL GBVideoStartup();
GBEXPORT VOID GBVideoCleanup();

GBEXPORT INT  GBVideoGetDeviceCount();
GBEXPORT INT  GBVideoGetAutoDetectedDevice();
GBEXPORT VOID GBVideoGetDeviceInfo(LPGBVIDEODEVICEINFO pInfo, INT nIndex);
GBEXPORT INT  GBVideoGetCurrentDevice();

GBEXPORT BOOL GBVideoStartupDevice(LPGBVIDEOSTARTUPDEVICEINFO pInfo = NULL);
GBEXPORT VOID GBVideoCleanupDevice();

GBEXPORT INT  GBVideoGetModeCount();
GBEXPORT VOID GBVideoGetModeInfo(LPGBVIDEOMODEINFO pInfo, INT nIndex);
GBEXPORT INT  GBVideoGetVideoMemoryTotal();
GBEXPORT INT  GBVideoGetVideoMemoryFree();

GBEXPORT BOOL GBVideoGetVideoMode(LPINT pnWidth, LPINT pdneight, LPINT pnBpp, LPBOOL pbFullScreen);
GBEXPORT BOOL GBVideoSetVideoMode(INT nWidth, INT nHeight);
GBEXPORT BOOL GBVideoSetVideoMode(INT nWidth, INT nHeight, INT nBpp);
GBEXPORT VOID GBVideoRestoreVideoMode();
GBEXPORT VOID GBVideoClear(GBVIDEOCOLOR color = 0, INT nBuffer = GBVIDEO_BACKBUFFER);
GBEXPORT VOID GBVideoFillRect(CONST LPRECT prect, GBVIDEOCOLOR color = 0, INT nBuffer = GBVIDEO_BACKBUFFER);
GBEXPORT BOOL GBVideoSetShowMode(DWORD dwMode);
GBEXPORT BOOL GBVideoShow();
GBEXPORT BOOL GBVideoFlipToGDI();
GBEXPORT BOOL GBVideoSetFade(INT nFade = 0, GBVIDEOCOLOR cFadeOut = 0);
GBEXPORT BOOL GBVideoSetGamma(INT nGamma = 65536);

GBEXPORT BOOL GBVideoIsLost();
GBEXPORT BOOL GBVideoRestore();

// DirectX Interface

GBEXPORT VOID GBVideoGetDirectDrawInterface(LPDIRECTDRAW4* pdd);
GBEXPORT VOID GBVideoGetDirectDrawSurfaceInterface(
	LPDIRECTDRAWSURFACE4* pddsPrim, LPDIRECTDRAWSURFACE4* pddsBack);

/////////////////////////////////////////////////////////////////////////////
#endif
/////////////////////////////////////////////////////////////////////////////
