/////////////////////////////////////////////////////////////////////////////
// GliD3D_GlideManagement.cpp : No comment
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "StdHdr.h"
#pragma hdrstop
#include "GliD3D.h"

/////////////////////////////////////////////////////////////////////////////
// Defines / Variables

/////////////////////////////////////////////////////////////////////////////
// Prototypes

/////////////////////////////////////////////////////////////////////////////
// Implements

FX_ENTRY void FX_CALL
grGlideInit( void )
{
	TRACEFUNCTION("grGlideInit");

	// Initialize system variables

	g_gr_hWndOld = NULL;
	g_gr_bOpenedWindow = FALSE;
	g_gr_bSplashed = FALSE;
	g_gr_nWidth = 0;
	g_gr_nHeight= 0;
	g_gr_bFullScreen = TRUE;

	g_gr_pd3ddevice = NULL;
	
	g_gr_nColBuffers = 0;
	g_gr_nAuxBuffers = 0;

	g_gr_nTrianglePerFrame = 0;

	// Get application window
	g_gr_hWndOld = GetActiveWindow();
//	g_gr_hWndOld = GetForegroundWindow();
//	g_gr_hWndOld = GetDesktopWindow();
	GetWindowRect(g_gr_hWndOld, &g_gr_rcOld);

	CHAR pszName[256];
	GetWindowText(g_gr_hWndOld, pszName, sizeof(pszName));
	TRACE("GliD3D info : Window name = %s\n", pszName);

	// Create device window

	// Check GameBios system version
	GBVERSIONINFO verinfo;
	GBGetVersion(&verinfo);
	if (verinfo.dwMajorVersion == 0 &&
		verinfo.dwMinorVersion < 73)
	{
		MessageBox(NULL, "To must upgrade the GAMEBIOS.DLL\rGliD3D shutdown.", NULL, MB_OK);
		exit(-1);
		return;
	}
	if (!GBValidateGBSystems()) {
		MessageBox(NULL, "Failed to initialize the GAMEBIOS systems\rGliD3D shutdown.", NULL, MB_OK);
		exit(-1);
		return;
	}

	// Startup Gamebios systems
	GBSTARTUPINFO gbsi;
	gbsi.hWnd = g_gr_hWndOld;
	gbsi.hInstance = NULL;
	gbsi.guidApplication = GUID_NULL;
	gbsi.dwFlags = 0;
	gbsi.dwFlags = GBSTARTUP_DEBUGDUMP;
//	gbsi.dwFlags = GBSTARTUP_DEBUGDUMP | GBSTARTUP_ALLOCTRACE;
	if (GLID3D_DEBUGDUMP) {
		lstrcpy(gbsi.pszDebugDumpFile, GLID3D_DEBUGDUMPNAME);
	} else {
		lstrcpy(gbsi.pszDebugDumpFile, "");
	}
	GBStartup(&gbsi);
	TRACE("GliD3D info : Startup Gamebios succeeded\n");
}

FX_ENTRY void FX_CALL
grGlideShutdown( void )
{
	TRACEFUNCTION("grGlideShutdown");

	if (g_gr_bOpenedWindow) {
		grSstWinClose();
	}
	GBCleanup();
	MoveWindow(g_gr_hWndOld, g_gr_rcOld.left, g_gr_rcOld.top, g_gr_rcOld.right, g_gr_rcOld.bottom, TRUE);
}

FX_ENTRY void FX_CALL
grGlideGetVersion( char version[80] )
{
	TRACEFUNCTION("grGlideGetVersion");

	lstrcpy(version, "2.46");
}

FX_ENTRY void FX_CALL
grGlideGetState( GrState *state )
{
	TRACEFUNCTION("grGlideGetState");

	CopyMemory(state, &g_gr_state, sizeof(GLID3D_STATE));
}

FX_ENTRY void FX_CALL
grGlideSetState( const GrState *state )
{
	TRACEFUNCTION("grGlideSetState");

	CopyMemory(&g_gr_state, state, sizeof(GLID3D_STATE));
	grAlphaBlendFunction(g_gr_state.alpha_blend_function_rgb_sf,
						 g_gr_state.alpha_blend_function_rgb_df,
						 g_gr_state.alpha_blend_function_alpha_sf,
						 g_gr_state.alpha_blend_function_alpha_df);
	grClipWindow(g_gr_state.clip_window_minx,
				 g_gr_state.clip_window_miny,
				 g_gr_state.clip_window_maxx,
				 g_gr_state.clip_window_maxy);
	grCullMode(g_gr_state.cull_mode);
	grDepthBufferMode(g_gr_state.depth_buffer_mode);
	grDepthMask(g_gr_state.depth_mask);
	grDepthBufferFunction(g_gr_state.depth_buffer_function);
	grDepthBiasLevel(g_gr_state.depth_bias_level);
	grRenderBuffer(g_gr_state.render_buffer);

}

FX_ENTRY void FX_CALL
grGlideShamelessPlug(const FxBool on)
{
	TRACEFUNCTION("grGlideShamelessPlug");

	WARNING("Not supported yet");
}

FX_ENTRY void FX_CALL
grHints(GrHint_t hintType, FxU32 hintMask)
{
	TRACEFUNCTION("grHints");

	WARNING("Not supported yet");
}

/////////////////////////////////////////////////////////////////////////////
