/////////////////////////////////////////////////////////////////////////////
// GliD3D_HiLevelRender.cpp : No comment
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "StdHdr.h"
#pragma hdrstop
#include "GliD3D.h"

/////////////////////////////////////////////////////////////////////////////
// Defines / Variables

/////////////////////////////////////////////////////////////////////////////
// Prototypes

/////////////////////////////////////////////////////////////////////////////
// Implements

GREXPORT FX_ENTRY void FX_CALL
guAlphaSource( GrAlphaSource_t mode )
{
	TRACEFUNCTION("guAlphaSource");

}

GREXPORT FX_ENTRY void FX_CALL
guColorCombineFunction( GrColorCombineFnc_t fnc )
{
	TRACEFUNCTION("guColorCombineFunction");

	switch (fnc) {
	case GR_COLORCOMBINE_ZERO                         : grColorCombine(GR_COMBINE_FUNCTION_ZERO, GR_COMBINE_FACTOR_NONE, GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_NONE, FXFALSE); break;
	case GR_COLORCOMBINE_ITRGB                        : grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_NONE, FXFALSE); break;
	case GR_COLORCOMBINE_DECAL_TEXTURE                : grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE); break;
	case GR_COLORCOMBINE_TEXTURE_TIMES_CCRGB          : grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_CONSTANT, GR_COMBINE_OTHER_TEXTURE, FXFALSE); break;
	case GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB          : grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE); break;
	case GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB_ADD_ALPHA: grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE); break;
	case GR_COLORCOMBINE_TEXTURE_TIMES_ALPHA          : grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE); break;
	case GR_COLORCOMBINE_TEXTURE_ADD_ITRGB            : break;
	case GR_COLORCOMBINE_TEXTURE_SUB_ITRGB            : break;
	case GR_COLORCOMBINE_CCRGB                        : grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_ONE, GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_NONE, FXFALSE); break;
	case GR_COLORCOMBINE_CCRGB_BLEND_ITRGB_ON_TEXALPHA: break;
	case GR_COLORCOMBINE_DIFF_SPEC_A                  : break;
	case GR_COLORCOMBINE_DIFF_SPEC_B                  : break;
	case GR_COLORCOMBINE_ONE                          : grColorCombine(GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE, GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_NONE, FXFALSE); break;
	}
}

GREXPORT FX_ENTRY int FX_CALL
guEncodeRLE16( void *dst, 
               void *src, 
               FxU32 width, 
               FxU32 height )
{
	TRACEFUNCTION("guEncodeRLE16");

	WARNING("guEncodeRLE16\rEncode RLE16 not supported yet");
	return 0;
}

GREXPORT FX_ENTRY FxU16 * FX_CALL
guTexCreateColorMipMap( void )
{
	TRACEFUNCTION("guTexCreateColorMipMap");

	WARNING("guEncodeRLE16\rEncode RLE16 not supported yet");
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
