/////////////////////////////////////////////////////////////////////////////
// GliD3D_linearframebuffer.cpp : No comment
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "StdHdr.h"
#pragma hdrstop
#include "GliD3D.h"

/////////////////////////////////////////////////////////////////////////////
// Defines / Variables

/////////////////////////////////////////////////////////////////////////////
// Prototypes

/////////////////////////////////////////////////////////////////////////////
// Implements

FX_ENTRY FxBool FX_CALL
grLfbLock( GrLock_t type, GrBuffer_t buffer, GrLfbWriteMode_t writeMode,
           GrOriginLocation_t origin, FxBool pixelPipeline, 
           GrLfbInfo_t *info )
{
	TRACEFUNCTION("grLfbLock");

/*	if (!g_gr_bWarned) {
		g_gr_bWarned = TRUE;
		//	grSstWinClose();
		GBVideoFlipToGDI();
		MessageBox(g_gr_hWndOld, "GliD3D warning : grLfbLock\rLFB access not supported yet", NULL, MB_OK);
		GBVideoShow();
		//	_exit(-1);
	}
*/
	if (writeMode == GR_LFBWRITEMODE_ANY)
		writeMode = GR_LFBWRITEMODE_565;

	if (buffer == GR_BUFFER_DEPTHBUFFER) {
		WARNING("grLfbLock\rTo lock the depth buffer not supported yet");
		return FXFALSE;
	}	
	if (writeMode != GR_LFBWRITEMODE_565) {
		WARNING("grLfbLock\rExcept for 565 Write mode not supported yet");
		return FXFALSE;
	}	
	if (origin != GR_ORIGIN_UPPER_LEFT) {
		WARNING("grLfbLock\rExcept for UPPER LEFT origin not supported yet");
		return FXFALSE;
	}	

	switch (buffer) {
	case GR_BUFFER_FRONTBUFFER:
		{

//			TRACE("GliD3D info : Lock the Front buffer\n");

			if (g_gr_lfb_lock_info_front.bLocked) {
				WARNING("Couldn't lock the front buffer(Locked another)");
				return FXFALSE;
			}

			g_gr_lfb_lock_info_front.nSize = g_gr_ddsdPrim.lPitch * g_gr_nHeight;
			info->size = sizeof(GrLfbInfo_t);
//			info->lfbPtr = (VOID*)GBAllocEx(g_gr_lfb_lock_info_front.nSize, "LfbLock");	
//			info->strideInBytes = g_gr_ddsdPrim.lPitch;
			info->writeMode = writeMode;
			info->origin = origin;
			g_gr_lfb_lock_info_front.info = *info;

//			TRACE("GliD3D info : Allocate the lock buffer for %d bytes\n", g_gr_lfb_lock_info_front.nSize);

			// Lock the surface and read pixel from it
			if (g_gr_bOpenedWindow) {
				HRESULT hr;
				DDSURFACEDESC2 ddsd;
				ZeroMemory(&ddsd, sizeof(ddsd));
				ddsd.dwSize = sizeof(ddsd);
				hr = g_gr_pddsPrim->Lock(NULL, &ddsd, DDLOCK_READONLY | DDLOCK_WAIT, NULL);
				if (SUCCEEDED(hr)) {

//					if (!g_gr_bNoLFBLock)
//						CopyMemory(info->lfbPtr, ddsd.lpSurface, g_gr_lfb_lock_info_front.nSize);

					// Unlock the surface
//					g_gr_pddsPrim->Unlock(NULL);

					info->lfbPtr = ddsd.lpSurface;	
					info->strideInBytes = ddsd.lPitch;

//					TRACE("GliD3D info : OK to read\n");

				} else {
				
					TRACE("%s\n", GetDirectXError(hr));
				}
			}

			g_gr_lfb_lock_info_front.bLocked = TRUE;
			
			break;
		}
	case GR_BUFFER_BACKBUFFER:
		{
//			TRACE("GliD3D info : Lock the Back buffer\n");

			if (g_gr_lfb_lock_info_back.bLocked) {
				WARNING("Couldn't lock the back buffer(Locked another)");
				return FXFALSE;
			}

			g_gr_lfb_lock_info_back.nSize = g_gr_ddsdBack.lPitch * g_gr_nHeight;
			info->size = sizeof(GrLfbInfo_t);
//			info->lfbPtr = (VOID*)GBAllocEx(g_gr_lfb_lock_info_back.nSize, "LfbLock");	
//			info->strideInBytes = g_gr_ddsdBack.lPitch;
			info->writeMode = writeMode;
			info->origin = origin;
			g_gr_lfb_lock_info_back.info = *info;

//			TRACE("GliD3D info : Allocate the lock buffer for %d bytes\n", g_gr_lfb_lock_info_back.nSize);

			// Lock the surface and read pixel from it
			if (g_gr_bOpenedWindow) {
				HRESULT hr;
				DDSURFACEDESC2 ddsd;
				ZeroMemory(&ddsd, sizeof(ddsd));
				ddsd.dwSize = sizeof(ddsd);
				hr = g_gr_pddsBack->Lock(NULL, &ddsd, DDLOCK_READONLY | DDLOCK_WAIT, NULL);
				if (SUCCEEDED(hr)) {

//					if (!g_gr_bNoLFBLock)
//						CopyMemory(info->lfbPtr, ddsd.lpSurface, g_gr_lfb_lock_info_back.nSize);

					// Unlock the surface
//					g_gr_pddsBack->Unlock(NULL);

					info->lfbPtr = ddsd.lpSurface;	
					info->strideInBytes = ddsd.lPitch;

//					TRACE("GliD3D info : OK to read\n");

				} else {
				
					TRACE("%s\n", GetDirectXError(hr));
				}
			}

			g_gr_lfb_lock_info_back.bLocked = TRUE;

			break;
		}

	}

//	TRACE("GliD3D info : Locked the Lfb\n");

	return FXTRUE;
}

FX_ENTRY FxBool FX_CALL
grLfbUnlock( GrLock_t type, GrBuffer_t buffer )
{
	TRACEFUNCTION("grLfbUnlock");

	if (!g_gr_bOpenedWindow) return FALSE;

	switch (buffer) {
	case GR_BUFFER_FRONTBUFFER:
		{
//			TRACE("GliD3D info : Unlock the Front buffer\n");

			if (!g_gr_lfb_lock_info_front.bLocked) {
				WARNING("Couldn't unlock the front buffer(No locked)");
				return FXFALSE;
			}

			if (type != GR_LFB_READ_ONLY) {

				// Lock the surface and write pixel to it
				if (g_gr_bOpenedWindow) {
//					HRESULT hr;
					DDSURFACEDESC2 ddsd;
					ZeroMemory(&ddsd, sizeof(ddsd));
					ddsd.dwSize = sizeof(ddsd);
//					hr = g_gr_pddsPrim->Lock(NULL, &ddsd, DDLOCK_WRITEONLY | DDLOCK_WAIT, NULL);
//					if (SUCCEEDED(hr)) {

//						if (!g_gr_bNoLFBLock)
//							CopyMemory(ddsd.lpSurface, g_gr_lfb_lock_info_front.info.lfbPtr, g_gr_lfb_lock_info_front.nSize);

						// Unlock the surface
						g_gr_pddsPrim->Unlock(NULL);

//						TRACE("GliD3D info : OK to write\n");

//					} else {
					
//						TRACE("%s\n", GetDirectXError(hr));
//					}
				}
			}

//			GBFree(g_gr_lfb_lock_info_front.info.lfbPtr);
			g_gr_lfb_lock_info_front.bLocked = FALSE;

			break;
		}
	case GR_BUFFER_BACKBUFFER:
		{
//			TRACE("GliD3D info : Unlock the Back buffer\n");

			if (!g_gr_lfb_lock_info_back.bLocked) {
				WARNING("Couldn't lock the back buffer(No locked)");
				return FXFALSE;
			}

			if (type != GR_LFB_READ_ONLY) {

				// Lock the surface and write pixel to it
				if (g_gr_bOpenedWindow) {
//					HRESULT hr;
					DDSURFACEDESC2 ddsd;
					ZeroMemory(&ddsd, sizeof(ddsd));
					ddsd.dwSize = sizeof(ddsd);
//					hr = g_gr_pddsBack->Lock(NULL, &ddsd, DDLOCK_WRITEONLY | DDLOCK_WAIT, NULL);
//					if (SUCCEEDED(hr)) {

//						if (!g_gr_bNoLFBLock)
//							CopyMemory(ddsd.lpSurface, g_gr_lfb_lock_info_back.info.lfbPtr, g_gr_lfb_lock_info_back.nSize);

						// Unlock the surface
						g_gr_pddsBack->Unlock(NULL);

//						TRACE("GliD3D info : OK to write\n");

//					} else {
					
//						TRACE("%s\n", GetDirectXError(hr));
//					}
				}
			}

//			GBFree(g_gr_lfb_lock_info_back.info.lfbPtr);
			g_gr_lfb_lock_info_back.bLocked = FALSE;

			break;
		}
	}

//	TRACE("GliD3D info : Unlocked the Lfb\n");

	return FXTRUE;
}

FX_ENTRY void FX_CALL 
grLfbConstantAlpha( GrAlpha_t alpha )
{
	TRACEFUNCTION("grLfbConstantAlpha");

	WARNING("LFB access not supported yet");
}

FX_ENTRY void FX_CALL 
grLfbConstantDepth( FxU16 depth )
{
	TRACEFUNCTION("grLfbConstantDepth");

	WARNING("LFB access not supported yet");
}

FX_ENTRY void FX_CALL 
grLfbWriteColorSwizzle(FxBool swizzleBytes, FxBool swapWords)
{
	TRACEFUNCTION("grLfbWriteColorSwizzle");

	WARNING("LFB access not supported yet");
}

FX_ENTRY void FX_CALL
grLfbWriteColorFormat(GrColorFormat_t colorFormat)
{
	TRACEFUNCTION("grLfbWriteColorFormat");

	WARNING("LFB access not supported yet");
}

FX_ENTRY FxBool FX_CALL
grLfbWriteRegion( GrBuffer_t dst_buffer, 
                  FxU32 dst_x, FxU32 dst_y, 
                  GrLfbSrcFmt_t src_format, 
                  FxU32 src_width, FxU32 src_height, 
                  FxI32 src_stride, void *src_data )

{
	TRACEFUNCTION("grLfbWriteRegion");

	WARNING("LFB access not supported yet");
	return FXFALSE;
}

FX_ENTRY FxBool FX_CALL
grLfbReadRegion( GrBuffer_t src_buffer,
                 FxU32 src_x, FxU32 src_y,
                 FxU32 src_width, FxU32 src_height,
                 FxU32 dst_stride, void *dst_data )
{
	TRACEFUNCTION("grLfbReadRegion");

	WARNING("LFB access not supported yet");
	return FXFALSE;
}

/////////////////////////////////////////////////////////////////////////////
