/////////////////////////////////////////////////////////////////////////////
// glid3d_SST.cpp : No comment
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "stdhdr.h"
#pragma hdrstop
#include "glid3d.h"

/////////////////////////////////////////////////////////////////////////////
// Variables

/////////////////////////////////////////////////////////////////////////////
// Implements

FX_ENTRY void FX_CALL 
grFinish(void)
{
	TRACEFUNCTION("grFinish");

}

FX_ENTRY void FX_CALL 
grFlush(void)
{
	TRACEFUNCTION("grFlush");

}

FX_ENTRY GrContext_t FX_CALL 
grSstWinOpen(
          FxU32                hWnd,
          GrScreenResolution_t screen_resolution,
          GrScreenRefresh_t    refresh_rate,
          GrColorFormat_t      color_format,
          GrOriginLocation_t   origin_location,
          int                  nColBuffers,
          int                  nAuxBuffers)
{
	TRACEFUNCTION("grSstWinOpen");

	HRESULT hr;
	INT i, j;

	// Get some info from Profile
	CHAR pszProfileName[_MAX_PATH];
	CHAR pszSection[32];
	CHAR pszKey[32];
	CHAR pszString[256];
	CHAR pszDevice[256];
	INT nGammaBase;
	BOOL bNoVsync;
	INT nWidth, nHeight;
	BOOL bNoSplash;
	BOOL bNoSplashSound;

	lstrcpy(pszProfileName, "");
	GetSystemDirectory(pszProfileName, sizeof(pszProfileName));
	if (pszProfileName[lstrlen(pszProfileName) - 1] != '\\')
		lstrcat(pszProfileName, "\\");
	lstrcat(pszProfileName, GLID3D_PROFILENAME);

	// Video info
	lstrcpy(pszSection, GLID3DPROF_VIDEO);

	lstrcpy(pszKey, GLID3DPROF_VIDEO_DEVICE);
	GliD3DGetProfileString(pszSection, pszKey, "Unknown", pszDevice, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_NOGAMMACONTROL);
	g_gr_bNoGammaControl = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_GAMMABASE);
	nGammaBase = GliD3DGetProfileInt(pszSection, pszKey, 0, pszProfileName);
	g_gr_fGammaBase = (FLOAT)nGammaBase / 100.0f;
	lstrcpy(pszKey, GLID3DPROF_VIDEO_CONTRAST);
	g_gr_nContrast = GliD3DGetProfileInt(pszSection, pszKey, 10000, pszProfileName);

	lstrcpy(pszKey, GLID3DPROF_VIDEO_MODE_512x384);
	GliD3DGetProfileString(pszSection, pszKey, "512x384", pszString, pszProfileName);
	sscanf(pszString, "%dx%d", &nWidth, &nHeight);
	g_gr_aResolution[GR_RESOLUTION_512x384].nWidth = nWidth;
	g_gr_aResolution[GR_RESOLUTION_512x384].nHeight = nHeight;

	lstrcpy(pszKey, GLID3DPROF_VIDEO_MODE_640x400);
	GliD3DGetProfileString(pszSection, pszKey, "640x400", pszString, pszProfileName);
	sscanf(pszString, "%dx%d", &nWidth, &nHeight);
	g_gr_aResolution[GR_RESOLUTION_640x400].nWidth = nWidth;
	g_gr_aResolution[GR_RESOLUTION_640x400].nHeight = nHeight;

	lstrcpy(pszKey, GLID3DPROF_VIDEO_MODE_640x480);
	GliD3DGetProfileString(pszSection, pszKey, "640x480", pszString, pszProfileName);
	sscanf(pszString, "%dx%d", &nWidth, &nHeight);
	g_gr_aResolution[GR_RESOLUTION_640x480].nWidth = nWidth;
	g_gr_aResolution[GR_RESOLUTION_640x480].nHeight = nHeight;

	lstrcpy(pszKey, GLID3DPROF_VIDEO_MODE_800x600);
	GliD3DGetProfileString(pszSection, pszKey, "800x600", pszString, pszProfileName);
	sscanf(pszString, "%dx%d", &nWidth, &nHeight);
	g_gr_aResolution[GR_RESOLUTION_800x600].nWidth = nWidth;
	g_gr_aResolution[GR_RESOLUTION_800x600].nHeight = nHeight;

	lstrcpy(pszKey, GLID3DPROF_VIDEO_MODE_1024x768);
	GliD3DGetProfileString(pszSection, pszKey, "1024x768", pszString, pszProfileName);
	sscanf(pszString, "%dx%d", &nWidth, &nHeight);
	g_gr_aResolution[GR_RESOLUTION_1024x768].nWidth = nWidth;
	g_gr_aResolution[GR_RESOLUTION_1024x768].nHeight = nHeight;

	lstrcpy(pszKey, GLID3DPROF_VIDEO_16BPP);
	g_gr_n16BPP = GliD3DGetProfileInt(pszSection, pszKey, 16, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_24BPP);
	g_gr_n24BPP = GliD3DGetProfileInt(pszSection, pszKey, 24, pszProfileName);

	lstrcpy(pszKey, GLID3DPROF_VIDEO_TEXTUREREDUCEMEMORY);
	g_gr_nReduceTexture = GliD3DGetProfileInt(pszSection, pszKey, 0, pszProfileName);
	switch (g_gr_nReduceTexture) {
	case 1  : g_gr_nReduceTexture = 2; break;
	case 2  : g_gr_nReduceTexture = 4; break;
	case 3  : g_gr_nReduceTexture = 8; break;
	case 4  : g_gr_nReduceTexture = 16; break;
	case 5  : g_gr_nReduceTexture = 32; break;
	case 6  : g_gr_nReduceTexture = 64; break;
	default : g_gr_nReduceTexture = 1;
	}

	lstrcpy(pszKey, GLID3DPROF_VIDEO_NOFOG);
	g_gr_bNoFog = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);

	lstrcpy(pszKey, GLID3DPROF_VIDEO_SCALINGFIX);
	g_gr_bScaleFix = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_NOVSYNC);
	bNoVsync = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_STEREO);
	g_gr_bStereo = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_SOFTWAREEMULATION);
	g_gr_bSoftwareEmulation = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_UVFIX);
	g_gr_bUVFix = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_WINDOWMODE);
	g_gr_bWindowMode = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_VIDEO_USEZFORW);
	g_gr_bUseZForW = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);

	// Splash info
	lstrcpy(pszSection, GLID3DPROF_SPLASH);

	lstrcpy(pszKey, GLID3DPROF_SPLASH_NOSPLASH);
	bNoSplash = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);
	lstrcpy(pszKey, GLID3DPROF_SPLASH_NOSOUND);
	bNoSplashSound = GliD3DGetProfileInt(pszSection, pszKey, FALSE, pszProfileName);


	// Initialize system variables
	g_gr_pdd = NULL;
	g_gr_pd3ddevice = NULL;

	// Initialize states
	g_gr_hWnd = NULL;
	g_gr_nWidth = 0;
	g_gr_nHeight = 0;
	g_gr_bFullScreen = 0;
	g_gr_bLeft = TRUE;
	g_gr_pdd = NULL;
	g_gr_pddsPrim = NULL;
	g_gr_pddsBack = NULL;
	g_gr_pddsLockTmp = NULL;
	g_gr_pd3ddevice = NULL;
	g_gr_nNumTextureFormats = 0;
	g_gr_nColBuffers = 0;
	g_gr_nAuxBuffers = 0;
	g_gr_bOpenedWindow = FALSE;
	g_gr_lfb_lock_info_front.bLocked = FALSE;
	g_gr_lfb_lock_info_back.bLocked = FALSE;

	// System
	g_gr_state.color_format = GR_COLORFORMAT_ABGR;
	g_gr_state.origin_location = GR_ORIGIN_UPPER_LEFT;
	g_gr_state.render_buffer = GR_BUFFER_BACKBUFFER;
	g_gr_state.cull_mode = GR_CULL_DISABLE;

	// Clip window
	g_gr_state.clip_window_minx = 0;
	g_gr_state.clip_window_miny = 0;
	g_gr_state.clip_window_maxx = 640;
	g_gr_state.clip_window_maxy = 480;

	// Chromakey
	g_gr_state.chromakey_mode = GR_CHROMAKEY_DISABLE;
	g_gr_state.chromakey_value = 0;

	// Depth buffer
	g_gr_state.depth_buffer_mode = GR_DEPTHBUFFER_DISABLE;
	g_gr_state.depth_mask = FXTRUE;
	g_gr_state.depth_buffer_function = GR_CMP_LEQUAL;
	g_gr_state.depth_bias_level = 0;

	// Color combine
	g_gr_state.constant_color_value = 0;
	g_gr_state.color_combine_function = GR_COMBINE_FUNCTION_LOCAL;
	g_gr_state.color_combine_factor = GR_COMBINE_FACTOR_NONE;
	g_gr_state.color_combine_local = GR_COMBINE_LOCAL_CONSTANT;
	g_gr_state.color_combine_other = GR_COMBINE_OTHER_NONE;

	// Alpha combine / function
	g_gr_state.alpha_combine_function = GR_COMBINE_FUNCTION_LOCAL;
	g_gr_state.alpha_combine_factor = GR_COMBINE_FACTOR_NONE;
	g_gr_state.alpha_combine_local = GR_COMBINE_LOCAL_CONSTANT;
	g_gr_state.alpha_combine_other = GR_COMBINE_OTHER_NONE;
	g_gr_state.alpha_blend_function_rgb_sf = GR_BLEND_ONE;
	g_gr_state.alpha_blend_function_rgb_df = GR_BLEND_ZERO;	
	g_gr_state.alpha_blend_function_alpha_sf = GR_BLEND_ZERO;
	g_gr_state.alpha_blend_function_alpha_df = GR_BLEND_ZERO;

	// TMU
	for (i = 0; i < GLID3D_NUM_TMU; i++) {
		g_gr_tmu[i].texture_minfilter_mode = GR_TEXTUREFILTER_POINT_SAMPLED;
		g_gr_tmu[i].texture_magfilter_mode = GR_TEXTUREFILTER_POINT_SAMPLED;
		g_gr_tmu[i].mipmap_mode = GR_MIPMAP_DISABLE;

		g_gr_tmu[i].texture_combine_rgb_function = GR_COMBINE_FUNCTION_LOCAL;
		g_gr_tmu[i].texture_combine_rgb_factor = GR_COMBINE_FACTOR_NONE;
		g_gr_tmu[i].texture_combine_alpha_function = GR_COMBINE_FUNCTION_LOCAL;
		g_gr_tmu[i].texture_combine_alpha_factor = GR_COMBINE_FACTOR_NONE;

		g_gr_tmu[i].texture_source_start_address = 0;
		g_gr_tmu[i].texture_source_start_address_old = -1;
		g_gr_tmu[i].texture_source_even_odd = GR_MIPMAPLEVELMASK_EVEN;

		for (j = 0; j < GLID3D_TEXMAXADDRESS; j++) {
			g_gr_tmu[i].texture[j].pd3dtexture = NULL;
			g_gr_tmu[i].texture[j].pddsurface = NULL;
		}
	}

	// Setup video mode and 3d device	
	if (hWnd) {

		GBCleanup();
		GBSTARTUPINFO gbsi;
		gbsi.hWnd = (HWND)hWnd;
		gbsi.hInstance = NULL;
		gbsi.guidApplication = GUID_NULL;
		gbsi.dwFlags = 0;
		gbsi.dwFlags = GBSTARTUP_DEBUGDUMP;
		if (GLID3D_DEBUGDUMP) {
			lstrcpy(gbsi.pszDebugDumpFile, GLID3D_DEBUGDUMPNAME);
		} else {
			lstrcpy(gbsi.pszDebugDumpFile, "");
		}
		GBStartup(&gbsi);
/*
		g_gr_hWndOld = GetActiveWindow();
		CHAR pszName[256];
		GetWindowText(g_gr_hWndOld, pszName, sizeof(pszName));
		TRACE("GliD3D info : Window name = %s\n", pszName);

		GBCleanup();
		GBSTARTUPINFO gbsi;
		gbsi.hWnd = g_gr_hWndOld;
		gbsi.hInstance = NULL;
		gbsi.guidApplication = GUID_NULL;
		gbsi.dwFlags = 0;
		gbsi.dwFlags = GBSTARTUP_DEBUGDUMP;
		if (GLID3D_DEBUGDUMP) {
			lstrcpy(gbsi.pszDebugOutput, GLID3D_DEBUGDUMPNAME);
		} else {
			lstrcpy(gbsi.pszDebugOutput, "");
		}
		GBStartup(&gbsi);
*/
	} else {

		g_gr_hWndOld = GetActiveWindow();
		CHAR pszName[256];
		GetWindowText(g_gr_hWndOld, pszName, sizeof(pszName));
		TRACE("GliD3D info : Window name = %s\n", pszName);

		GBCleanup();
		GBSTARTUPINFO gbsi;
		gbsi.hWnd = g_gr_hWndOld;
		gbsi.hInstance = NULL;
		gbsi.guidApplication = GUID_NULL;
		gbsi.dwFlags = 0;
		gbsi.dwFlags = GBSTARTUP_DEBUGDUMP;
		if (GLID3D_DEBUGDUMP) {
			lstrcpy(gbsi.pszDebugDumpFile, GLID3D_DEBUGDUMPNAME);
		} else {
			lstrcpy(gbsi.pszDebugDumpFile, "");
		}
		GBStartup(&gbsi);

	}

	g_gr_nWidth = g_gr_aResolution[screen_resolution].nWidth;
	g_gr_nHeight = g_gr_aResolution[screen_resolution].nHeight;
	switch (screen_resolution) {
	case GR_RESOLUTION_512x384  :
		g_gr_nGlideWidth = 512;
		g_gr_nGlideHeight = 384;
		g_gr_fWidthScale = (FLOAT)g_gr_nWidth /  512.0f;
		g_gr_fHeightScale = (FLOAT)g_gr_nHeight / 384.0f;
		break;
	case GR_RESOLUTION_640x400  :
		g_gr_nGlideWidth = 640;
		g_gr_nGlideHeight = 400;
		g_gr_fWidthScale = (FLOAT)g_gr_nWidth /  640.0f;
		g_gr_fHeightScale = (FLOAT)g_gr_nHeight / 400.0f;
		break;
	case GR_RESOLUTION_640x480  :
		g_gr_nGlideWidth = 640;
		g_gr_nGlideHeight = 480;
		g_gr_fWidthScale = (FLOAT)g_gr_nWidth /  640.0f;
		g_gr_fHeightScale = (FLOAT)g_gr_nHeight / 480.0f;
		break;
	case GR_RESOLUTION_800x600  :
		g_gr_nGlideWidth = 800;
		g_gr_nGlideHeight = 600;
		g_gr_fWidthScale = (FLOAT)g_gr_nWidth /  800.0f;
		g_gr_fHeightScale = (FLOAT)g_gr_nHeight / 600.0f;
		break;
	case GR_RESOLUTION_1024x768 :
		g_gr_nGlideWidth = 1024;
		g_gr_nGlideHeight = 768;
		g_gr_fWidthScale = (FLOAT)g_gr_nWidth / 1024.0f;
		g_gr_fHeightScale = (FLOAT)g_gr_nHeight / 768.0f;
		break;
	}
	g_gr_state.color_format = color_format;
	g_gr_state.origin_location = origin_location;
	g_gr_nColBuffers = nColBuffers;
	g_gr_nAuxBuffers = nAuxBuffers;
	g_gr_state.clip_window_minx = 0;
	g_gr_state.clip_window_miny = 0;
	g_gr_state.clip_window_maxx = g_gr_nWidth;
	g_gr_state.clip_window_maxy = g_gr_nHeight;

	g_gr_fGlideWidth = (FLOAT)g_gr_nGlideWidth;
	g_gr_fGlideHeight = (FLOAT)g_gr_nGlideHeight;
	g_gr_fWidth = (FLOAT)g_gr_nWidth;
	g_gr_fHeight = (FLOAT)g_gr_nHeight;
	g_gr_fHarfWidth = (FLOAT)g_gr_nWidth / 2.0f;
	g_gr_fHarfHeight = (FLOAT)g_gr_nHeight / 2.0f;

	// Print info
	TRACE("------------------------------------------------------------\n");
	TRACE("GliD3D info : grSstWinOpen\n");
	TRACE("------------------------------------------------------------\n");
	TRACE("              Screen resolution = %d x %d\n", g_gr_nWidth, g_gr_nHeight);
	TRACE("              Color format = %s\n",
		color_format == GR_COLORFORMAT_ARGB ? "GR_COLORFORMAT_ARGB" :
		color_format == GR_COLORFORMAT_ABGR ? "GR_COLORFORMAT_ABGR" :
		color_format == GR_COLORFORMAT_RGBA ? "GR_COLORFORMAT_RGBA" :
		color_format == GR_COLORFORMAT_BGRA ? "GR_COLORFORMAT_BGRA" : "Unknown"
	);
	TRACE("              Origin location = %s\n",
		origin_location == GR_ORIGIN_UPPER_LEFT ? "GR_ORIGIN_UPPER_LEFT" :
		origin_location == GR_ORIGIN_LOWER_LEFT ? "GR_ORIGIN_LOWER_LEFT" : "Unknown"
	);
	TRACE("              Number of Col buffers = %2d\n", nColBuffers);
	TRACE("              Number of Aux buffers = %2d\n", nAuxBuffers);
	TRACE("              Profile = %s\n", pszProfileName);
	TRACE("              Device = %s\n", pszDevice);
	TRACE("              Texture reduce memory = 1/%d\n", g_gr_nReduceTexture);
	TRACE("------------------------------------------------------------\n\n");

	// Startup Gamebios systems
	if (lstrcmpi(pszDevice, "Unknown") == 0) {
		if (!GBVideoStartup()) goto failed_to_startup_gamebios;
	} else {
		if (!GBVideoStartup()) goto failed_to_startup_gamebios;
	}
	INT nNumVideoDevices;
	nNumVideoDevices = GBVideoGetDeviceCount();
	GBVIDEODEVICEINFO gbvdi;
	for (i = 0; nNumVideoDevices; i++) {
		GBVideoGetDeviceInfo(&gbvdi, i);
		if (lstrcmp(pszDevice, gbvdi.pszName) == 0) break;
	}
	if (i >= nNumVideoDevices) i = 0;
	GBVIDEOSTARTUPDEVICEINFO gbvsdi;
	gbvsdi.nDevice = i;
	gbvsdi.dwFlags = 0;
	GBVideoStartupDevice(&gbvsdi);
	BOOL bSucceeded;
	if (g_gr_bWindowMode)
		bSucceeded = GBVideoSetVideoMode(g_gr_nWidth, g_gr_nHeight, 0);
	else
		bSucceeded = GBVideoSetVideoMode(g_gr_nWidth, g_gr_nHeight, g_gr_n16BPP);
	if (!bSucceeded) {
		TRACE("GliD3D warning : Failed to change video mode\n");
		MessageBox(NULL, "GliD3D warning : grSstWinOpen\rFailed to change video mode", NULL, MB_OK);
		goto failed_to_startup_gamebios;
	}

	if (!GB2DStartup()) goto failed_to_startup_gamebios;
	if (!GB3DStartup()) goto failed_to_startup_gamebios;

	if (bNoVsync) {
		GBVideoSetShowMode(GBVIDEOSHOWMODE_BLT);
	}

	// Find HAL device
	GB3DEnableHardwareDevice(!g_gr_bSoftwareEmulation);
	INT nNumDevices;
	INT nHALDevice;
	nNumDevices = GB3DGetDeviceCount();
	nHALDevice = -1;
	GB3DDEVICEINFO devinfo;
	TRACE("------------------------------------------------------------\n");
	TRACE("GliD3D info : Number of Direct3D Devices = %2d\n", nNumDevices);
	TRACE("------------------------------------------------------------\n");
	for (i = 0; i < nNumDevices; i++) {
		GB3DGetDeviceInfo(&devinfo, i);
		TRACE("              Direct3D Device %2d --- %s\n", i, devinfo.pszName);
		if (devinfo.bHardware) {
			nHALDevice = i;
		}
	}
	if (nHALDevice == -1) {
//		TRACE("GliD3D warning : Couldn't found Direct3D HAL Device\n");
//		GBVideoRestoreVideoMode();
//		MessageBox(g_gr_hWndOld, "GliD3D warning : grSstWinOpen\rDirect3D HAL Device required", NULL, MB_OK);
//		goto failed_to_startup_gamebios;
		g_gr_bSoftwareEmulation = TRUE;
		TRACE("------------------------------------------------------------\n");
		TRACE("              HAL Device not detected, Use software emulation\n");
		TRACE("------------------------------------------------------------\n\n");
	} else {
		TRACE("------------------------------------------------------------\n");
		TRACE("              HAL Device detected %2d\n", nHALDevice);
		TRACE("------------------------------------------------------------\n\n");
	}

	// Clear the front buffer and back buffer
	GBVideoClear();
	GBVideoShow();

	// Startup device
	GB3DSTARTUPDEVICEINFO sdinfo;
	sdinfo.nRenderTarget = GBVIDEO_BACKBUFFER;
	sdinfo.nDevice = nHALDevice;
	sdinfo.nZBufferFormat = -1;
	sdinfo.dwFlags = (nAuxBuffers == 0 ? GB3DSTARTUPDEVICE_NOZBUFFER : 0);
	if (!GB3DStartupDevice(&sdinfo)) {
		TRACE("GliD3D warning : Couldn't startup device\n");
		GBVideoRestoreVideoMode();
		MessageBox(g_gr_hWndOld, "GliD3D warning : grSstWinOpen\rFailed to initialize 3D Device", NULL, MB_OK);
		CHAR pszError[256];
		GBErrorGetLastError(pszError);
		MessageBox(g_gr_hWndOld, pszError, NULL, MB_OK);
		goto failed_to_startup_gamebios;
	}

	// Get texture format info
	INT nNumTextureFormats;
	nNumTextureFormats = GB3DGetTextureFormatCount();
	GB3DTEXTUREFORMATINFO texinfo;
	TRACE("------------------------------------------------------------\n");
	TRACE("GliD3D info : Number of Texture formats = %2d\n", nNumTextureFormats);
	TRACE("------------------------------------------------------------\n");
	for (i = 0; i < nNumTextureFormats; i++) {
		GB3DGetTextureFormatInfo(&texinfo, i);
		g_gr_texture_format[i] = texinfo;
		TRACE("              Texture format %2d --- %s", i, texinfo.pszName);
		if (texinfo.bPalette) {
			TRACE("\n");
		} else {
			TRACE(" R%2d(%3d) G%2d(%3d) B%2d(%3d) A%2d(%3d)\n",
				texinfo.nRShifts, texinfo.nRMax,
				texinfo.nGShifts, texinfo.nGMax,
				texinfo.nBShifts, texinfo.nBMax,
				texinfo.nAShifts, texinfo.nAMax
			);
		}
	}
	g_gr_nNumTextureFormats = i;
	TRACE("------------------------------------------------------------\n\n");

	// Find optimal Direct3D texture format for Glide
	TRACE("------------------------------------------------------------\n");
	TRACE("GliD3D info : Find optimal Direct3D texture format for Glide\n");
	TRACE("------------------------------------------------------------\n");
	// GR_TEXFMT_RGB_332
	TRACE("              GR_TEXFMT_RGB_332 --- ");
	for (i = 0; i < nNumTextureFormats; i++) {
		if (g_gr_texture_format[i].nRBits == 3 && g_gr_texture_format[i].nGBits == 3 && g_gr_texture_format[i].nBBits == 2 &&
			g_gr_texture_format[i].nABits == 0 && g_gr_texture_format[i].bPalette == FALSE) break;
	}
	if (i >= nNumTextureFormats) {
		for (i = 0; i < nNumTextureFormats; i++) {
			if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 6 && g_gr_texture_format[i].nBBits == 5 &&
				g_gr_texture_format[i].nABits == 0 && g_gr_texture_format[i].bPalette == FALSE) break;
		}
		if (i >= nNumTextureFormats) {
			for (i = 0; i < nNumTextureFormats; i++) {
				if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 5 && g_gr_texture_format[i].nBBits == 5 &&
					g_gr_texture_format[i].nABits == 0 && g_gr_texture_format[i].bPalette == FALSE) break;
			}
			if (i >= nNumTextureFormats) {
				TRACE("Couldn't found\n");
				goto failed_to_startup_gamebios;
			}
		}
	}
	g_gr_texfmt[GR_TEXFMT_RGB_332].nFormat = i;
	TRACE("%d\n", i);
	// GR_TEXFMT_YIQ_422
	TRACE("              GR_TEXFMT_YIQ_422 --- ");
	g_gr_texfmt[GR_TEXFMT_YIQ_422].nFormat = -1;
	TRACE("Not supported yet\n");
	// GR_TEXFMT_ALPHA_8
	TRACE("              GR_TEXFMT_ALPHA_8 --- ");
	for (i = 0; i < nNumTextureFormats; i++) {
		if (g_gr_texture_format[i].nRBits == 0 && g_gr_texture_format[i].nGBits == 0 && g_gr_texture_format[i].nBBits == 0 &&
			g_gr_texture_format[i].nABits == 8 && g_gr_texture_format[i].bPalette == FALSE) break;
	}
	if (i >= nNumTextureFormats) {
		for (i = 0; i < nNumTextureFormats; i++) {
			if (g_gr_texture_format[i].nRBits == 4 && g_gr_texture_format[i].nGBits == 4 && g_gr_texture_format[i].nBBits == 4 &&
				g_gr_texture_format[i].nABits == 4 && g_gr_texture_format[i].bPalette == FALSE) break;
		}
		if (i >= nNumTextureFormats) {
			for (i = 0; i < nNumTextureFormats; i++) {
				if (g_gr_texture_format[i].nRBits == 8 && g_gr_texture_format[i].nGBits == 8 && g_gr_texture_format[i].nBBits == 8 &&
					g_gr_texture_format[i].nABits == 8 && g_gr_texture_format[i].bPalette == FALSE) break;
			}
			if (i >= nNumTextureFormats) {
				for (i = 0; i < nNumTextureFormats; i++) {
					if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 5 && g_gr_texture_format[i].nBBits == 5 &&
						g_gr_texture_format[i].nABits == 1 && g_gr_texture_format[i].bPalette == FALSE) break;
				}
				if (i < nNumTextureFormats) {
					TRACE("Couldn't found\n");
					goto failed_to_startup_gamebios;
				}
			}
		}
	}
	g_gr_texfmt[GR_TEXFMT_ALPHA_8].nFormat = i;
	TRACE("%d\n", i);
	// GR_TEXFMT_INTENSITY_8
	TRACE("              GR_TEXFMT_INTENSITY_8 --- ");
	g_gr_texfmt[GR_TEXFMT_INTENSITY_8] = g_gr_texfmt[GR_TEXFMT_ALPHA_8];
	TRACE("Same GR_TEXFMT_ALPHA_8\n");
	// GR_TEXFMT_ALPHA_INTENSITY_44
	TRACE("              GR_TEXFMT_ALPHA_INTENSITY_44 --- ");
	g_gr_texfmt[GR_TEXFMT_ALPHA_INTENSITY_44].nFormat = -1;
	TRACE("Not supported yet\n");
	// GR_TEXFMT_P_8
	TRACE("              GR_TEXFMT_P_8 --- ");
	for (i = 0; i < nNumTextureFormats; i++) {
		if (g_gr_texture_format[i].nBits == 8 && g_gr_texture_format[i].bPalette == TRUE) break;
	}
	if (i >= nNumTextureFormats) {
		for (i = 0; i < nNumTextureFormats; i++) {
//			if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 5 && g_gr_texture_format[i].nBBits == 5 &&
//				g_gr_texture_format[i].nABits == 0 && g_gr_texture_format[i].bPalette == FALSE) break;
			if (g_gr_texture_format[i].nRBits == 3 && g_gr_texture_format[i].nGBits == 3 && g_gr_texture_format[i].nBBits == 2 &&
				g_gr_texture_format[i].nABits == 0 && g_gr_texture_format[i].bPalette == FALSE) break;
		}
		if (i >= nNumTextureFormats) {
			for (i = 0; i < nNumTextureFormats; i++) {
				if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 6 && g_gr_texture_format[i].nBBits == 5 &&
					g_gr_texture_format[i].nABits == 0 && g_gr_texture_format[i].bPalette == FALSE) break;
			}
			if (i >= nNumTextureFormats) {
				TRACE("Couldn't found\n");
				goto failed_to_startup_gamebios;
			}
		}
	}
	g_gr_texfmt[GR_TEXFMT_P_8].nFormat = i;
	TRACE("%d\n", i);
	// GR_TEXFMT_ARGB_8332
	TRACE("              GR_TEXFMT_ARGB_8332 --- ");
	for (i = 0; i < nNumTextureFormats; i++) {
		if (g_gr_texture_format[i].nRBits == 8 && g_gr_texture_format[i].nGBits == 3 && g_gr_texture_format[i].nBBits == 3 &&
			g_gr_texture_format[i].nABits == 2 && g_gr_texture_format[i].bPalette == FALSE) break;
	}
	if (i >= nNumTextureFormats) {
		for (i = 0; i < nNumTextureFormats; i++) {
			if (g_gr_texture_format[i].nRBits == 4 && g_gr_texture_format[i].nGBits == 4 && g_gr_texture_format[i].nBBits == 4 &&
				g_gr_texture_format[i].nABits == 4 && g_gr_texture_format[i].bPalette == FALSE) break;
		}
		if (i >= nNumTextureFormats) {
			for (i = 0; i < nNumTextureFormats; i++) {
				if (g_gr_texture_format[i].nRBits == 8 && g_gr_texture_format[i].nGBits == 8 && g_gr_texture_format[i].nBBits == 8 &&
					g_gr_texture_format[i].nABits == 8 && g_gr_texture_format[i].bPalette == FALSE) break;
			}
			if (i >= nNumTextureFormats) {
				for (i = 0; i < nNumTextureFormats; i++) {
					if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 5 && g_gr_texture_format[i].nBBits == 5 &&
						g_gr_texture_format[i].nABits == 1 && g_gr_texture_format[i].bPalette == FALSE) break;
				}
				if (i >= nNumTextureFormats) {
					TRACE("Couldn't found\n");
					goto failed_to_startup_gamebios;
				}
			}
		}
	}
	g_gr_texfmt[GR_TEXFMT_ARGB_8332].nFormat = i;
	TRACE("%d\n", i);
	// GR_TEXFMT_AYIQ_8422
	TRACE("              GR_TEXFMT_AYIQ_8422 --- ");
	g_gr_texfmt[GR_TEXFMT_AYIQ_8422].nFormat = -1;
	TRACE("Not supported yet\n");
	// GR_TEXFMT_RGB_565
	TRACE("              GR_TEXFMT_RGB_565 --- ");
	for (i = 0; i < nNumTextureFormats; i++) {
		if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 6 && g_gr_texture_format[i].nBBits == 5 &&
			g_gr_texture_format[i].nABits == 0 && g_gr_texture_format[i].bPalette == FALSE) break;
//		if (g_gr_texture_format[i].nRBits == 3 && g_gr_texture_format[i].nGBits == 3 && g_gr_texture_format[i].nBBits == 2 &&
//			g_gr_texture_format[i].nABits == 0 && g_gr_texture_format[i].bPalette == FALSE) break;
	}
	if (i >= nNumTextureFormats) {
		for (i = 0; i < nNumTextureFormats; i++) {
			if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 5 && g_gr_texture_format[i].nBBits == 5 &&
				g_gr_texture_format[i].nABits == 0 && g_gr_texture_format[i].bPalette == FALSE) break;
		}
		if (i >= nNumTextureFormats) {
			for (i = 0; i < nNumTextureFormats; i++) {
				if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 5 && g_gr_texture_format[i].nBBits == 5 &&
					g_gr_texture_format[i].nABits == 1 && g_gr_texture_format[i].bPalette == FALSE) break;
			}
			if (i >= nNumTextureFormats) {
				TRACE("Couldn't found\n");
				goto failed_to_startup_gamebios;
			}
		}
	}
	g_gr_texfmt[GR_TEXFMT_RGB_565].nFormat = i;
	TRACE("%d\n", i);
	// GR_TEXFMT_ARGB_1555
	TRACE("              GR_TEXFMT_ARGB_1555 --- ");
	for (i = 0; i < nNumTextureFormats; i++) {
		if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 5 && g_gr_texture_format[i].nBBits == 5 &&
			g_gr_texture_format[i].nABits == 1 && g_gr_texture_format[i].bPalette == FALSE) break;
	}
	if (i >= nNumTextureFormats) {
		for (i = 0; i < nNumTextureFormats; i++) {
			if (g_gr_texture_format[i].nRBits == 4 && g_gr_texture_format[i].nGBits == 4 && g_gr_texture_format[i].nBBits == 4 &&
				g_gr_texture_format[i].nABits == 4 && g_gr_texture_format[i].bPalette == FALSE) break;
		}
		if (i >= nNumTextureFormats) {
			for (i = 0; i < nNumTextureFormats; i++) {
				if (g_gr_texture_format[i].nRBits == 8 && g_gr_texture_format[i].nGBits == 8 && g_gr_texture_format[i].nBBits == 8 &&
					g_gr_texture_format[i].nABits == 8 && g_gr_texture_format[i].bPalette == FALSE) break;
			}
			if (i >= nNumTextureFormats) {
				TRACE("Couldn't found\n");
				goto failed_to_startup_gamebios;
			}
		}
	}
	g_gr_texfmt[GR_TEXFMT_ARGB_1555].nFormat = i;
	TRACE("%d\n", i);
	// GR_TEXFMT_ARGB_4444
	TRACE("              GR_TEXFMT_ARGB_4444 --- ");
	for (i = 0; i < nNumTextureFormats; i++) {
		if (g_gr_texture_format[i].nRBits == 4 && g_gr_texture_format[i].nGBits == 4 && g_gr_texture_format[i].nBBits == 4 &&
			g_gr_texture_format[i].nABits == 4 && g_gr_texture_format[i].bPalette == FALSE) break;
	}
	if (i >= nNumTextureFormats) {
		for (i = 0; i < nNumTextureFormats; i++) {
			if (g_gr_texture_format[i].nRBits == 8 && g_gr_texture_format[i].nGBits == 8 && g_gr_texture_format[i].nBBits == 8 &&
				g_gr_texture_format[i].nABits == 8 && g_gr_texture_format[i].bPalette == FALSE) break;
		}
		if (i >= nNumTextureFormats) {
			for (i = 0; i < nNumTextureFormats; i++) {
				if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 5 && g_gr_texture_format[i].nBBits == 5 &&
					g_gr_texture_format[i].nABits == 1 && g_gr_texture_format[i].bPalette == FALSE) break;
			}
			if (i >= nNumTextureFormats) {
				TRACE("Couldn't found\n");
				goto failed_to_startup_gamebios;
			}
		}
	}
	g_gr_texfmt[GR_TEXFMT_ARGB_4444].nFormat = i;
	TRACE("%d\n", i);
	// GR_TEXFMT_ALPHA_INTENSITY_88
	TRACE("              GR_TEXFMT_ALPHA_INTENSITY_88 --- ");
	g_gr_texfmt[GR_TEXFMT_ALPHA_INTENSITY_88].nFormat = -1;
	TRACE("Not supported yet\n");
	// GR_TEXFMT_AP_88
	TRACE("              GR_TEXFMT_AP_88 --- ");
	for (i = 0; i < nNumTextureFormats; i++) {
		if (g_gr_texture_format[i].nRBits == 4 && g_gr_texture_format[i].nGBits == 4 && g_gr_texture_format[i].nBBits == 4 &&
			g_gr_texture_format[i].nABits == 4 && g_gr_texture_format[i].bPalette == FALSE) break;
	}
	if (i >= nNumTextureFormats) {
		for (i = 0; i < nNumTextureFormats; i++) {
			if (g_gr_texture_format[i].nRBits == 8 && g_gr_texture_format[i].nGBits == 8 && g_gr_texture_format[i].nBBits == 8 &&
				g_gr_texture_format[i].nABits == 8 && g_gr_texture_format[i].bPalette == FALSE) break;
		}
		if (i >= nNumTextureFormats) {
			for (i = 0; i < nNumTextureFormats; i++) {
				if (g_gr_texture_format[i].nRBits == 5 && g_gr_texture_format[i].nGBits == 5 && g_gr_texture_format[i].nBBits == 5 &&
					g_gr_texture_format[i].nABits == 1 && g_gr_texture_format[i].bPalette == FALSE) break;
			}
			if (i >= nNumTextureFormats) {
				TRACE("Couldn't found\n");
				goto failed_to_startup_gamebios;
			}
		}
	}
	g_gr_texfmt[GR_TEXFMT_AP_88].nFormat = i;
	TRACE("%d\n", i);
	TRACE("------------------------------------------------------------\n\n");

	// Get DirectDraw and Direct3DDevice interface from Gamebios
	GBVideoGetDirectDrawInterface(&g_gr_pdd);
	GBVideoGetDirectDrawSurfaceInterface(&g_gr_pddsPrim, &g_gr_pddsBack);
	GB3DGetDirect3DDeviceInterface(&g_gr_pd3ddevice);

	// Output system info
	ZeroMemory(&g_gr_ddsdPrim, sizeof(g_gr_ddsdPrim));
	g_gr_ddsdPrim.dwSize = sizeof(g_gr_ddsdPrim);
	g_gr_pddsPrim->GetSurfaceDesc(&g_gr_ddsdPrim);
	ZeroMemory(&g_gr_ddsdBack, sizeof(g_gr_ddsdBack));
	g_gr_ddsdBack.dwSize = sizeof(g_gr_ddsdBack);
	g_gr_pddsBack->GetSurfaceDesc(&g_gr_ddsdBack);
	TRACE("------------------------------------------------------------\n");
	TRACE("GliD3D info : System info\n");
	TRACE("------------------------------------------------------------\n");
	TRACE("              Front buffer pitch = %d\n", g_gr_ddsdPrim.lPitch);
	TRACE("              Back buffer pitch = %d\n", g_gr_ddsdBack.lPitch);

	// Lock the surface and read / write pixel test
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	hr = g_gr_pddsPrim->Lock(NULL, &ddsd, DDLOCK_WAIT | DDLOCK_NOSYSLOCK, NULL);
	if (SUCCEEDED(hr)) {
		LPWORD pSurfPtr = (LPWORD)ddsd.lpSurface;
		*pSurfPtr = 0;
		if (*pSurfPtr == 0) {
			*pSurfPtr = 255;
			if (*pSurfPtr == 255) {
				g_gr_pddsPrim->Unlock(NULL);
				TRACE("              Front buffer read / write passed\n");
			} else {
				g_gr_pddsPrim->Unlock(NULL);
				TRACE("              Front buffer read / write failed\n");
			}
		}
	}
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	hr = g_gr_pddsBack->Lock(NULL, &ddsd, DDLOCK_WAIT | DDLOCK_NOSYSLOCK, NULL);
	if (SUCCEEDED(hr)) {
		LPWORD pSurfPtr = (LPWORD)ddsd.lpSurface;
		*pSurfPtr = 0;
		if (*pSurfPtr == 0) {
			*pSurfPtr = 255;
			if (*pSurfPtr == 255) {
				g_gr_pddsBack->Unlock(NULL);
				TRACE("              Back buffer read / write passed\n");
			} else {
				g_gr_pddsBack->Unlock(NULL);
				TRACE("              Back buffer read / write failed\n");
			}
		}
	}

	// Texture system memory
	D3DDEVICEDESC d3dddHAL, d3dddHEL;
	ZeroMemory(&d3dddHAL, sizeof(d3dddHAL));
	d3dddHAL.dwSize = sizeof(d3dddHAL);
	ZeroMemory(&d3dddHEL, sizeof(d3dddHEL));
	d3dddHEL.dwSize = sizeof(d3dddHEL);
	g_gr_pd3ddevice->GetCaps(&d3dddHAL, &d3dddHEL);
	if (!g_gr_bSoftwareEmulation) {
		if (d3dddHAL.dwDevCaps & D3DDEVCAPS_TEXTURESYSTEMMEMORY) {
			g_gr_bCanTextureSystemMemory = TRUE;
			TRACE("              Can use texture on SYSTEM MEMORY\n");
		} else {
			g_gr_bCanTextureSystemMemory = FALSE;
			TRACE("              Can't use texture on SYSTEM MEMORY\n");
		}
	} else {
		if (d3dddHEL.dwDevCaps & D3DDEVCAPS_TEXTURESYSTEMMEMORY) {
			g_gr_bCanTextureSystemMemory = TRUE;
			TRACE("              Can use texture on SYSTEM MEMORY\n");
		} else {
			g_gr_bCanTextureSystemMemory = FALSE;
			TRACE("              Can't use texture on SYSTEM MEMORY\n");
		}
	}
	TRACE("------------------------------------------------------------\n\n");

	// Splash
	if (!bNoSplash && !g_gr_bSplashed) {
		GB3DSplashLetSoftware();
		g_gr_bSplashed = TRUE;
	}

	// Begin render
	GBVideoClear();
	GBVideoShow();
	GBVideoClear();
	GBVideoShow();
	GB3DBeginRender();

	// Initialize render state or Glide state
	g_gr_pd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREPERSPECTIVE, TRUE);
//	grGammaCorrectionValue(1.0f);
	grClipWindow(0, 0, g_gr_nGlideWidth, g_gr_nGlideHeight);
	grChromakeyMode(GR_CHROMAKEY_DISABLE);
	grFogColorValue(0x00ffffff);

	// Initialize GliD3D states
	BYTE state[512];//	GrState state;
	grGlideGetState(&state);
	grGlideSetState(&state);


	g_gr_bOpenedWindow = TRUE;

	TRACE("------------------------------------------------------------\n");
	TRACE("GliD3D info : grSstWinOpen succeeded\n");
	TRACE("------------------------------------------------------------\n\n");

	return FXTRUE;

failed_to_startup_gamebios:

	// Release the DirectX Interfaces
	if (g_gr_pd3ddevice) {
		GB3DEndRender();
		RELEASE(g_gr_pd3ddevice);
	}
	RELEASE(g_gr_pddsLockTmp);
	RELEASE(g_gr_pddsBack);
	RELEASE(g_gr_pddsPrim);
	RELEASE(g_gr_pdd);

	// Cleanup the Gamebios systems
	GB3DCleanupDevice();
	GBVideoRestoreVideoMode();
	GB3DCleanup();
	GB2DCleanup();
	GBVideoCleanupDevice();
	GBVideoCleanup();

	MessageBox(g_gr_hWnd, "GliD3D warning : grSstWinOpen\rFailed to startup\rGliD3D shutdown.", NULL, MB_OK);

//	PostQuitMessage(-1);		// Shutdown
//	exit(-1);					// Shutdown
	return FXFALSE;
}

FX_ENTRY FxBool FX_CALL
grSstWinClose( GrContext_t context )
{
	TRACEFUNCTION("grSstWinClose");

	TRACE("------------------------------------------------------------\n");
	TRACE("GliD3D info : grSstWinClose\n");
	TRACE("------------------------------------------------------------\n\n");

	INT i, j;
	for (i = 0; i < GLID3D_NUM_TMU; i++) {
		for (j = 0; j < GLID3D_TEXMAXADDRESS; j++) {
			RELEASE(g_gr_tmu[i].texture[j].pd3dtexture);
			RELEASE(g_gr_tmu[i].texture[j].pddsurface);
		}
	}

	// Restore gamma
	if (!g_gr_bNoGammaControl) {
		DDGAMMARAMP ddgammaramp;
		for (i = 0; i < 256; i++) {
			ddgammaramp.red[i] = (WORD)(i < 255 ? i * 256 : 0xffff);
			ddgammaramp.green[i] = (WORD)(i < 255 ? i * 256 : 0xffff);
			ddgammaramp.blue[i] = (WORD)(i < 255 ? i * 256 : 0xffff);
		}

		HRESULT hr;
		LPDIRECTDRAWGAMMACONTROL pddgamma = NULL;
		hr = g_gr_pddsPrim->QueryInterface(IID_IDirectDrawGammaControl, (VOID**)&pddgamma);
		if (SUCCEEDED(hr)) {
			pddgamma->SetGammaRamp(0, &ddgammaramp);
			RELEASE(pddgamma);
		}
	}

	// Release the DirectX Interfaces
	if (g_gr_pd3ddevice) {
		GB3DEndRender();
		RELEASE(g_gr_pd3ddevice);
	}
	RELEASE(g_gr_pddsBack);
	RELEASE(g_gr_pddsPrim);
	RELEASE(g_gr_pdd);

	// Cleanup the Gamebios systems
	GB3DCleanupDevice();
	GBVideoRestoreVideoMode();
	GB3DCleanup();
	GB2DCleanup();
	GBVideoCleanupDevice();
	GBVideoCleanup();

	HWND hWnd = g_gr_hWnd;
	InvalidateRect(hWnd, NULL, TRUE);
	ShowWindow(hWnd, SW_SHOW);
	ShowWindowAsync(hWnd, SW_SHOW);
	UpdateWindow(hWnd);


	g_gr_bOpenedWindow = FALSE;

	TRACE("------------------------------------------------------------\n");
	TRACE("GliD3D info : grSstWinClose succeeded\n");
	TRACE("------------------------------------------------------------\n\n");

	return TRUE;
}

FX_ENTRY FxBool FX_CALL
grSelectContext( GrContext_t context )
{
	TRACEFUNCTION("grSelectContext");

	return FXTRUE;
}


FX_ENTRY void FX_CALL
grSstOrigin(GrOriginLocation_t  origin)
{
	TRACEFUNCTION("grSstOrigin");

	g_gr_state.origin_location = origin;
}


FX_ENTRY void FX_CALL 
grSstSelect( int which_sst )
{
	TRACEFUNCTION("grSstSelect");

}


/////////////////////////////////////////////////////////////////////////////
