// GliD3DCfg.cpp
//

#include "StdAfx.h"
#include "GliD3DCfg.h"
#include "GliD3DCfgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGliD3DCfgApp

BEGIN_MESSAGE_MAP(CGliD3DCfgApp, CWinApp)
	//{{AFX_MSG_MAP(CGliD3DCfgApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGliD3DCfgApp

CGliD3DCfgApp::CGliD3DCfgApp()
{
	// TODO
}

/////////////////////////////////////////////////////////////////////////////
// CGliD3DCfgApp

CGliD3DCfgApp theApp;

CHAR g_pszProfileName[] = "GLID3D.INI";
CHAR g_pszDeviceName[256];
BOOL g_bNoFog;
BOOL g_bNoVsync;
BOOL g_bSoftwareEmulation;
BOOL g_bWindowMode;
BOOL g_bUseZForW;
BOOL g_bNoGammaControl;
INT g_nGammaBase;
INT g_nContrast;
INT g_nResolution[5];
INT g_nWidth[5];
INT g_nHeight[5];
INT g_nColor[2];
BOOL g_bScalingFix;
INT g_nTextureReduceMemory;

INT g_nNumModes;
GBVIDEOMODEINFO g_modeinfo[128];

/////////////////////////////////////////////////////////////////////////////
// CGliD3DCfgApp

BOOL CGliD3DCfgApp::InitInstance()
{
#ifdef _AFXDLL
	Enable3dControls();
#else
	Enable3dControlsStatic();
#endif

	lstrcpy(g_pszDeviceName, "");

	CGliD3DCfgDlg dlg;
	m_pMainWnd = &dlg;

	int nResponse;

	GBSTARTUPINFO sui;
	sui.hWnd = m_pMainWnd->m_hWnd;
	sui.hInstance = AfxGetInstanceHandle();
	sui.guidApplication = GUID_NULL;
	GBStartup(&sui);
	GBVideoStartup();

	CHAR pszProfileName[_MAX_PATH];
	lstrcpy(pszProfileName, "");
	GetSystemDirectory(pszProfileName, sizeof(pszProfileName));
	if (pszProfileName[lstrlen(pszProfileName) - 1] != '\\')
		lstrcat(pszProfileName, "\\");
	lstrcat(pszProfileName, g_pszProfileName);
	free((void*)m_pszProfileName);
	m_pszProfileName = _tcsdup(_T(pszProfileName));
	TRACE("PROFILE : %s\n", pszProfileName);

	INT nNumDevices;
	nNumDevices = GBVideoGetDeviceCount();

	if (nNumDevices) {

		CString strTmp;
		CHAR pszTmp[256];
		strTmp = GetProfileString("Video", "Device", "");
		lstrcpy(g_pszDeviceName, strTmp.GetBuffer(0));

		GBVideoStartupDevice();
		INT nNumModes;
		nNumModes = GBVideoGetModeCount();

		g_bNoGammaControl = GetProfileInt("Video", "NoGammaControl", 0);
		g_nGammaBase = GetProfileInt("Video", "GammaBase", 0);
		g_nContrast = GetProfileInt("Video", "Contrast", 8192);

		strTmp = GetProfileString("Video", "512x384", "512x384");
		lstrcpy(pszTmp, strTmp.GetBuffer(0));
		sscanf(pszTmp, "%dx%d", &g_nWidth[0], &g_nHeight[0]);
		strTmp = GetProfileString("Video", "640x400", "640x400");
		lstrcpy(pszTmp, strTmp.GetBuffer(0));
		sscanf(pszTmp, "%dx%d", &g_nWidth[1], &g_nHeight[1]);
		strTmp = GetProfileString("Video", "640x480", "640x480");
		lstrcpy(pszTmp, strTmp.GetBuffer(0));
		sscanf(pszTmp, "%dx%d", &g_nWidth[2], &g_nHeight[2]);
		strTmp = GetProfileString("Video", "800x600", "800x600");
		lstrcpy(pszTmp, strTmp.GetBuffer(0));
		sscanf(pszTmp, "%dx%d", &g_nWidth[3], &g_nHeight[3]);
		strTmp = GetProfileString("Video", "1024x768", "1024x768");
		lstrcpy(pszTmp, strTmp.GetBuffer(0));
		sscanf(pszTmp, "%dx%d", &g_nWidth[4], &g_nHeight[4]);
		g_nColor[0] = GetProfileInt("Video", "16BPP", 16);
		g_nColor[1] = GetProfileInt("Video", "24BPP", 24);
		
		GBVideoCleanupDevice();

		g_nTextureReduceMemory = GetProfileInt("Texture", "ReduceMemory", 0);
		g_bNoFog = GetProfileInt("Video", "NoFog", 0);
		g_bNoVsync = GetProfileInt("Video", "NoVsync", 0);
		g_bSoftwareEmulation = GetProfileInt("Video", "SoftwareEmulation", 0);
		g_bWindowMode = GetProfileInt("Video", "WindowMode", 0);
		g_bUseZForW = GetProfileInt("Video", "UseZforW", 0);
		g_bScalingFix = GetProfileInt("Video", "ScalingFix", 0);

		nResponse = dlg.DoModal();

	} else {

		MessageBox(m_pMainWnd->m_hWnd, "DirectDraw device dot found", NULL, MB_OK);
		nResponse = IDCANCEL;

	}

	GBVideoCleanupDevice();
	GBCleanup();

	if (nResponse == IDOK)
	{
		CHAR pszTmp[256];

		// Video
		WriteProfileString("Video", "Device", g_pszDeviceName);
		WriteProfileInt("Video", "NoGammaControl", g_bNoGammaControl);
		WriteProfileInt("Video", "GammaBase", g_nGammaBase);
		WriteProfileInt("Video", "Contrast", g_nContrast);
		wsprintf(pszTmp, "%dx%d", g_nWidth[0], g_nHeight[0]);
		WriteProfileString("Video", "512x384", pszTmp);
		wsprintf(pszTmp, "%dx%d", g_nWidth[1], g_nHeight[1]);
		WriteProfileString("Video", "640x400", pszTmp);
		wsprintf(pszTmp, "%dx%d", g_nWidth[2], g_nHeight[2]);
		WriteProfileString("Video", "640x480", pszTmp);
		wsprintf(pszTmp, "%dx%d", g_nWidth[3], g_nHeight[3]);
		WriteProfileString("Video", "800x600", pszTmp);
		wsprintf(pszTmp, "%dx%d", g_nWidth[4], g_nHeight[4]);
		WriteProfileString("Video", "1024x768", pszTmp);
		wsprintf(pszTmp, "%d", g_nColor[0]);
		WriteProfileString("Video", "16BPP", pszTmp);
		wsprintf(pszTmp, "%d", g_nColor[1]);
		WriteProfileString("Video", "24BPP", pszTmp);
		WriteProfileInt("Texture", "ReduceMemory", g_nTextureReduceMemory);
		WriteProfileInt("Video", "NoFog", g_bNoFog);
		WriteProfileInt("Video", "NoVsync", g_bNoVsync);
		WriteProfileInt("Video", "SoftwareEmulation", g_bSoftwareEmulation);
		WriteProfileInt("Video", "WindowMode", g_bWindowMode);
		WriteProfileInt("Video", "UseZforW", g_bUseZForW);
		WriteProfileInt("Video", "ScalingFix", g_bScalingFix);
		WriteProfileInt("Video", "Stereo", 0);

		// Splash
//		WriteProfileString("Splash", "NoSplash", "0");
//		WriteProfileString("Splash", "NoSound", "0");
	}
	else if (nResponse == IDCANCEL)
	{
	}

	return FALSE;
}
