// GliD3DCfgDlg.cpp
//

#include "StdAfx.h"
#include "GliD3DCfg.h"
#include "GliD3DCfgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementations
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGliD3DCfgDlg

CGliD3DCfgDlg::CGliD3DCfgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGliD3DCfgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGliD3DCfgDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGliD3DCfgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGliD3DCfgDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGliD3DCfgDlg, CDialog)
	//{{AFX_MSG_MAP(CGliD3DCfgDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO_DEVICE, OnSelchangeComboDevice)
	ON_BN_CLICKED(IDC_CHECK_NOGAMMACONTROL, OnCheckNogammacontrol)
	ON_CBN_SELCHANGE(IDC_COMBO_COL16, OnSelchangeComboCol16)
	ON_CBN_SELCHANGE(IDC_COMBO_COL24, OnSelchangeComboCol24)
	ON_CBN_SELCHANGE(IDC_COMBO_RES1024X768, OnSelchangeComboRes1024x768)
	ON_CBN_SELCHANGE(IDC_COMBO_RES512X384, OnSelchangeComboRes512x384)
	ON_CBN_SELCHANGE(IDC_COMBO_RES640X400, OnSelchangeComboRes640x400)
	ON_CBN_SELCHANGE(IDC_COMBO_RES640X480, OnSelchangeComboRes640x480)
	ON_CBN_SELCHANGE(IDC_COMBO_RES800X600, OnSelchangeComboRes800x600)
	ON_BN_CLICKED(IDC_CHECK_NOFOG, OnCheckNofog)
	ON_BN_CLICKED(IDC_CHECK_NOVSYNC, OnCheckNovsync)
	ON_BN_CLICKED(IDC_CHECK_SCALINGFIX, OnCheckScalingfix)
	ON_BN_CLICKED(IDC_CHECK_SOFTWAREEMULATION, OnCheckSoftwareemulation)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_CHECK_WINDOWMODE, OnCheckWindowmode)
	ON_BN_CLICKED(IDC_CHECK_USEZFORW, OnCheckUsezforw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGliD3DCfgDlg

BOOL CGliD3DCfgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	// Setup driver combobox
	CComboBox* pcomboDevice;
	INT nNumDevices;
	nNumDevices = GBVideoGetDeviceCount();
	pcomboDevice = (CComboBox*)GetDlgItem(IDC_COMBO_DEVICE);

	if (nNumDevices > 0) {

		// Found one or more devices
		INT i;
		GBVIDEODEVICEINFO di;
		for (i = 0; i < nNumDevices; i++) {
			GBVideoGetDeviceInfo(&di, i);
			pcomboDevice->SetItemData(pcomboDevice->AddString(di.pszName), i);
			if (i == 0) pcomboDevice->SetCurSel(0);
			if (lstrcmpi(di.pszName, g_pszDeviceName) == 0) pcomboDevice->SetCurSel(i);
		}

	} else {
		OnCancel();
	}
	OnSelchangeComboDevice();

	// Setup checkbox controls
	CButton* pcheckNoGammaControl;
	pcheckNoGammaControl = (CButton*)GetDlgItem(IDC_CHECK_NOGAMMACONTROL);
	pcheckNoGammaControl->SetCheck(g_bNoGammaControl);
	OnCheckNogammacontrol();
	pcheckNoGammaControl->EnableToolTips(TRUE);

	CButton* pcheckNoFog;
	pcheckNoFog = (CButton*)GetDlgItem(IDC_CHECK_NOFOG);
	pcheckNoFog->SetCheck(g_bNoFog);
	OnCheckNofog();

	CButton* pcheckNoVsync;
	pcheckNoVsync = (CButton*)GetDlgItem(IDC_CHECK_NOVSYNC);
	pcheckNoVsync->SetCheck(g_bNoVsync);
	OnCheckNovsync();
	
	CButton* pcheckScalingFix;
	pcheckScalingFix = (CButton*)GetDlgItem(IDC_CHECK_SCALINGFIX);
	pcheckScalingFix->SetCheck(g_bScalingFix);
	OnCheckScalingfix();

	CButton* pcheckSoftwareEmulation;
	pcheckSoftwareEmulation = (CButton*)GetDlgItem(IDC_CHECK_SOFTWAREEMULATION);
	pcheckSoftwareEmulation->SetCheck(g_bSoftwareEmulation);
	OnCheckSoftwareemulation();

	CButton* pcheckWindowMode;
	pcheckWindowMode = (CButton*)GetDlgItem(IDC_CHECK_WINDOWMODE);
	pcheckWindowMode->SetCheck(g_bWindowMode);
	OnCheckWindowmode();

	CButton* pcheckUseZForW;
	pcheckUseZForW = (CButton*)GetDlgItem(IDC_CHECK_USEZFORW);
	pcheckUseZForW->SetCheck(g_bUseZForW);
	OnCheckUsezforw();

	// Setup slider controls
	CSliderCtrl* psliderTextureReduceMemory;
	psliderTextureReduceMemory = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_TEXTUREREDUCEMEMORY);
	psliderTextureReduceMemory->SetRange(0, 5);
	psliderTextureReduceMemory->SetLineSize(1);
	psliderTextureReduceMemory->SetPageSize(5);
	psliderTextureReduceMemory->SetPos(g_nTextureReduceMemory);
	OnHScroll(TB_THUMBTRACK, g_nTextureReduceMemory, (CScrollBar*)psliderTextureReduceMemory);

	CSliderCtrl* psliderGammaBase;
	psliderGammaBase = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_GAMMABASE);
	psliderGammaBase->SetRange(0, 1000);
	psliderGammaBase->SetLineSize(10);
	psliderGammaBase->SetPageSize(100);
	psliderGammaBase->SetPos(g_nGammaBase);
	OnHScroll(TB_THUMBTRACK, g_nGammaBase, (CScrollBar*)psliderGammaBase);

	CSliderCtrl* psliderContrast;
	psliderContrast = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_CONTRAST);
	psliderContrast->SetRange(0, 65535);
	psliderContrast->SetLineSize(256);
	psliderContrast->SetPageSize(8192);
	psliderContrast->SetPos(g_nContrast);
	OnHScroll(TB_THUMBTRACK, g_nContrast, (CScrollBar*)psliderContrast);

	return TRUE;
}

void CGliD3DCfgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CGliD3DCfgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CGliD3DCfgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGliD3DCfgDlg::OnSelchangeComboDevice() 
{
	// TODO

	CComboBox* pcomboDevice;
	pcomboDevice = (CComboBox*)GetDlgItem(IDC_COMBO_DRIVER);
	pcomboDevice->GetLBText(pcomboDevice->GetCurSel(), g_pszDeviceName);

	INT nDevice = pcomboDevice->GetItemData(pcomboDevice->GetCurSel());
	GBVIDEODEVICEINFO di;
	GBVideoGetDeviceInfo(&di, nDevice);

	GBVIDEOSTARTUPDEVICEINFO gbvsdi;
	gbvsdi.nDevice = nDevice;
	gbvsdi.dwFlags = 0;

	GBVideoStartupDevice(&gbvsdi);
	INT nNumModes;
	nNumModes = GBVideoGetModeCount();
	g_nNumModes = nNumModes;

	CComboBox* pcomboRes512x384, * pcomboRes640x400, * pcomboRes640x480, * pcomboRes800x600, * pcomboRes1024x768;
	pcomboRes512x384 = (CComboBox*)GetDlgItem(IDC_COMBO_RES512X384);
	pcomboRes640x400 = (CComboBox*)GetDlgItem(IDC_COMBO_RES640X400);
	pcomboRes640x480 = (CComboBox*)GetDlgItem(IDC_COMBO_RES640X480);
	pcomboRes800x600 = (CComboBox*)GetDlgItem(IDC_COMBO_RES800X600);
	pcomboRes1024x768 = (CComboBox*)GetDlgItem(IDC_COMBO_RES1024X768);

	pcomboRes512x384->ResetContent();
	pcomboRes640x400->ResetContent();
	pcomboRes640x480->ResetContent();
	pcomboRes800x600->ResetContent();
	pcomboRes1024x768->ResetContent();

	CComboBox* pcomboCol16, * pcomboCol24;
	pcomboCol16 = (CComboBox*)GetDlgItem(IDC_COMBO_COL16);
	pcomboCol24 = (CComboBox*)GetDlgItem(IDC_COMBO_COL24);

	pcomboCol16->ResetContent();
	pcomboCol24->ResetContent();

	if (nNumModes > 0) {

		BOOL bCol8 = FALSE, bCol16 = FALSE, bCol24 = FALSE, bCol32 = FALSE;
		INT nCurSelRes512x384 = 0, nCurSelRes640x400 = 0, nCurSelRes640x480 = 0, nCurSelRes800x600 = 0, nCurSelRes1024x768 = 0;
		INT nCurSelCol16 = 0, nCurSelCol24 = 0;
		INT i, nResCount = 0, nColCount = 0;
		CHAR pszName[256];
		GBVIDEOMODEINFO mi;
		for (i = 0; i < nNumModes; i++) {
			GBVideoGetModeInfo(&mi, i);
			g_modeinfo[i] = mi;
			if (mi.nBpp == 16) {
				wsprintf(pszName, "%d x %d", mi.nWidth, mi.nHeight);
				pcomboRes512x384->SetItemData(pcomboRes512x384->AddString(pszName), i);
				pcomboRes640x400->SetItemData(pcomboRes640x400->AddString(pszName), i);
				pcomboRes640x480->SetItemData(pcomboRes640x480->AddString(pszName), i);
				pcomboRes800x600->SetItemData(pcomboRes800x600->AddString(pszName), i);
				pcomboRes1024x768->SetItemData(pcomboRes1024x768->AddString(pszName), i);
				if (mi.nWidth <= g_nWidth[0] && mi.nHeight <= g_nHeight[0]) nCurSelRes512x384 = nResCount;
				if (mi.nWidth <= g_nWidth[1] && mi.nHeight <= g_nHeight[1]) nCurSelRes640x400 = nResCount;
				if (mi.nWidth <= g_nWidth[2] && mi.nHeight <= g_nHeight[2]) nCurSelRes640x480 = nResCount;
				if (mi.nWidth <= g_nWidth[3] && mi.nHeight <= g_nHeight[3]) nCurSelRes800x600 = nResCount;
				if (mi.nWidth <= g_nWidth[4] && mi.nHeight <= g_nHeight[4]) nCurSelRes1024x768 = nResCount;
				nResCount++;
			}
			if (mi.nBpp == 8 && !bCol8) {
				wsprintf(pszName, "%d bit", mi.nBpp);
				pcomboCol16->SetItemData(pcomboCol16->AddString(pszName), i);
				pcomboCol24->SetItemData(pcomboCol24->AddString(pszName), i);
				bCol8 = TRUE;
				if (g_nColor[0] == 8) nCurSelCol16 = nColCount;
				if (g_nColor[1] == 8) nCurSelCol24 = nColCount;
				nColCount++;
			}
			if (mi.nBpp == 16 && !bCol16) {
				wsprintf(pszName, "%d bit", mi.nBpp);
				pcomboCol16->SetItemData(pcomboCol16->AddString(pszName), i);
				pcomboCol24->SetItemData(pcomboCol24->AddString(pszName), i);
				bCol16 = TRUE;
				if (g_nColor[0] == 16) nCurSelCol16 = nColCount;
				if (g_nColor[1] == 16) nCurSelCol24 = nColCount;
				nColCount++;
			}
			if (mi.nBpp == 24 && !bCol24) {
				wsprintf(pszName, "%d bit", mi.nBpp);
				pcomboCol16->SetItemData(pcomboCol16->AddString(pszName), i);
				pcomboCol24->SetItemData(pcomboCol24->AddString(pszName), i);
				bCol24 = TRUE;
				if (g_nColor[0] == 24) nCurSelCol16 = nColCount;
				if (g_nColor[1] == 24) nCurSelCol24 = nColCount;
				nColCount++;
			}
			if (mi.nBpp == 32 && !bCol32) {
				wsprintf(pszName, "%d bit", mi.nBpp);
				pcomboCol16->SetItemData(pcomboCol16->AddString(pszName), i);
				pcomboCol24->SetItemData(pcomboCol24->AddString(pszName), i);
				bCol32 = TRUE;
				if (g_nColor[0] == 32) nCurSelCol16 = nColCount;
				if (g_nColor[1] == 32) nCurSelCol24 = nColCount;
				nColCount++;
			}
		}

		pcomboRes512x384->SetCurSel(nCurSelRes512x384);
		pcomboRes640x400->SetCurSel(nCurSelRes640x400);
		pcomboRes640x480->SetCurSel(nCurSelRes640x480);
		pcomboRes800x600->SetCurSel(nCurSelRes800x600);
		pcomboRes1024x768->SetCurSel(nCurSelRes1024x768);

		pcomboCol16->SetCurSel(nCurSelCol16);
		pcomboCol24->SetCurSel(nCurSelCol24);

	}

	GBVideoCleanupDevice();

	DWORD dwFlags = di.dwFlags;
	CStatic* p3DDevice;
	p3DDevice = (CStatic*)GetDlgItem(IDC_STATIC_3DDEVICE);
	p3DDevice->EnableWindow(dwFlags & GBVIDEODEVICE_3DDEVICE);

	CStatic* pWindowmode;
	pWindowmode = (CStatic*)GetDlgItem(IDC_STATIC_WINDOWMODE);
	pWindowmode->EnableWindow(dwFlags & GBVIDEODEVICE_WINDOWMODE);

	CStatic* pGammaControl;
	pGammaControl = (CStatic*)GetDlgItem(IDC_STATIC_GAMMACONTROL);
	pGammaControl->EnableWindow(dwFlags & GBVIDEODEVICE_GAMMACONTROL);

	CStatic* pColorControl;
	pColorControl = (CStatic*)GetDlgItem(IDC_STATIC_COLORCONTROL);
	pColorControl->EnableWindow(dwFlags & GBVIDEODEVICE_COLORCONTROL);
}

void CGliD3DCfgDlg::OnOK() 
{
	// TODO
//	UpdateData();

	CComboBox* pcomboDevice;
	pcomboDevice = (CComboBox*)GetDlgItem(IDC_COMBO_DRIVER);
	pcomboDevice->GetLBText(pcomboDevice->GetCurSel(), g_pszDeviceName);

	CDialog::OnOK();
}

void CGliD3DCfgDlg::OnCheckNogammacontrol() 
{
	// TODO

	CButton* pcheckNoGammaControl;
	pcheckNoGammaControl = (CButton*)GetDlgItem(IDC_CHECK_NOGAMMACONTROL);

	CSliderCtrl* psliderGammaBase;
	psliderGammaBase = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_GAMMABASE);
	CSliderCtrl* psliderContrast;
	psliderContrast = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_CONTRAST);

	if (pcheckNoGammaControl->GetCheck()) {
		// Checked
		psliderGammaBase->EnableWindow(FALSE);
		psliderContrast->EnableWindow(FALSE);

	} else {
		// Unchecked
		psliderGammaBase->EnableWindow(TRUE);
		psliderContrast->EnableWindow(TRUE);

	}
	
	g_bNoGammaControl = pcheckNoGammaControl->GetCheck();
}

void CGliD3DCfgDlg::OnSelchangeComboCol16() 
{
	// TODO
	INT nColor;
	CComboBox* pcomboCol16;
	pcomboCol16 = (CComboBox*)GetDlgItem(IDC_COMBO_COL16);
	nColor = pcomboCol16->GetItemData(pcomboCol16->GetCurSel());
	g_nColor[0] = g_modeinfo[nColor].nBpp;	
}

void CGliD3DCfgDlg::OnSelchangeComboCol24() 
{
	// TODO
	INT nColor;
	CComboBox* pcomboCol24;
	pcomboCol24 = (CComboBox*)GetDlgItem(IDC_COMBO_COL24);
	nColor = pcomboCol24->GetItemData(pcomboCol24->GetCurSel());
	g_nColor[1] = g_modeinfo[nColor].nBpp;	
}

void CGliD3DCfgDlg::OnSelchangeComboRes512x384() 
{
	// TODO
	INT nMode;
	CComboBox* pcomboRes512x384;
	pcomboRes512x384 = (CComboBox*)GetDlgItem(IDC_COMBO_RES512X384);
	nMode = pcomboRes512x384->GetItemData(pcomboRes512x384->GetCurSel());
	g_nWidth[0] = g_modeinfo[nMode].nWidth;
	g_nHeight[0] = g_modeinfo[nMode].nHeight;
	g_nResolution[0] = nMode;
}

void CGliD3DCfgDlg::OnSelchangeComboRes640x400() 
{
	// TODO
	INT nMode;
	CComboBox* pcomboRes640x400;
	pcomboRes640x400 = (CComboBox*)GetDlgItem(IDC_COMBO_RES640X400);
	nMode = pcomboRes640x400->GetItemData(pcomboRes640x400->GetCurSel());
	g_nWidth[1] = g_modeinfo[nMode].nWidth;
	g_nHeight[1] = g_modeinfo[nMode].nHeight;
	g_nResolution[1] = nMode;
}

void CGliD3DCfgDlg::OnSelchangeComboRes640x480() 
{
	// TODO
	INT nMode;
	CComboBox* pcomboRes640x480;
	pcomboRes640x480 = (CComboBox*)GetDlgItem(IDC_COMBO_RES640X480);
	nMode = pcomboRes640x480->GetItemData(pcomboRes640x480->GetCurSel());
	g_nWidth[2] = g_modeinfo[nMode].nWidth;
	g_nHeight[2] = g_modeinfo[nMode].nHeight;
	g_nResolution[2] = nMode;
}

void CGliD3DCfgDlg::OnSelchangeComboRes800x600() 
{
	// TODO
	INT nMode;
	CComboBox* pcomboRes800x600;
	pcomboRes800x600 = (CComboBox*)GetDlgItem(IDC_COMBO_RES800X600);
	nMode = pcomboRes800x600->GetItemData(pcomboRes800x600->GetCurSel());
	g_nWidth[3] = g_modeinfo[nMode].nWidth;
	g_nHeight[3] = g_modeinfo[nMode].nHeight;
	g_nResolution[3] = nMode;
}

void CGliD3DCfgDlg::OnSelchangeComboRes1024x768() 
{
	// TODO
	INT nMode;
	CComboBox* pcomboRes1024x768;
	pcomboRes1024x768 = (CComboBox*)GetDlgItem(IDC_COMBO_RES1024X768);
	nMode = pcomboRes1024x768->GetItemData(pcomboRes1024x768->GetCurSel());
	g_nWidth[4] = g_modeinfo[nMode].nWidth;
	g_nHeight[4] = g_modeinfo[nMode].nHeight;
	g_nResolution[4] = nMode;
}

void CGliD3DCfgDlg::OnCheckNofog() 
{
	// TODO
	CButton* pcheckNoFog;
	pcheckNoFog = (CButton*)GetDlgItem(IDC_CHECK_NOFOG);
	g_bNoFog = pcheckNoFog->GetCheck();
}

void CGliD3DCfgDlg::OnCheckNovsync() 
{
	// TODO
	CButton* pcheckNoVsync;
	pcheckNoVsync = (CButton*)GetDlgItem(IDC_CHECK_NOVSYNC);
	g_bNoVsync = pcheckNoVsync->GetCheck();
}

void CGliD3DCfgDlg::OnCheckScalingfix() 
{
	// TODO
	CButton* pcheckScalingFix;
	pcheckScalingFix = (CButton*)GetDlgItem(IDC_CHECK_SCALINGFIX);
	g_bScalingFix = pcheckScalingFix->GetCheck();
}

void CGliD3DCfgDlg::OnCheckSoftwareemulation() 
{
	// TODO
	CButton* pcheckSoftwareEmulation;
	pcheckSoftwareEmulation = (CButton*)GetDlgItem(IDC_CHECK_SOFTWAREEMULATION);
	g_bSoftwareEmulation = pcheckSoftwareEmulation->GetCheck();
}

void CGliD3DCfgDlg::OnCheckWindowmode() 
{
	// TODO
	CButton* pcheckWindowMode;
	pcheckWindowMode = (CButton*)GetDlgItem(IDC_CHECK_WINDOWMODE);
	g_bWindowMode = pcheckWindowMode->GetCheck();
}

void CGliD3DCfgDlg::OnCheckUsezforw() 
{
	// TODO
	CButton* pcheckUseZForW;
	pcheckUseZForW = (CButton*)GetDlgItem(IDC_CHECK_USEZFORW);
	g_bUseZForW = pcheckUseZForW->GetCheck();
}

void CGliD3DCfgDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO
	if (pScrollBar == GetDlgItem(IDC_SLIDER_TEXTUREREDUCEMEMORY)) {

//		if (nSBCode & (TB_BOTTOM | TB_LINEDOWN | TB_LINEUP | TB_PAGEDOWN | TB_PAGEUP | TB_THUMBTRACK | TB_TOP)) {
		
			INT nValue;
			CSliderCtrl* psliderTextureReduceMemory;
			psliderTextureReduceMemory = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_TEXTUREREDUCEMEMORY);
			nValue = psliderTextureReduceMemory->GetPos();

			CHAR pszTmp[256];
			if (nValue == 0) {
				wsprintf(pszTmp, "0");
			} else {
				wsprintf(pszTmp, "1 / %d", 1 << nValue);
			}
			CStatic* pstaticTextureReduceMemoryValue = (CStatic*)GetDlgItem(IDC_STATIC_TEXTUREREDUCEMEMORYVALUE);
			pstaticTextureReduceMemoryValue->SetWindowText(pszTmp);
			g_nTextureReduceMemory = nValue;

//		}

		return;

	} else if (pScrollBar == GetDlgItem(IDC_SLIDER_GAMMABASE)) {

//		if (nSBCode & (TB_BOTTOM | TB_LINEDOWN | TB_LINEUP | TB_PAGEDOWN | TB_PAGEUP | TB_THUMBTRACK | TB_TOP)) {
		
			INT nValue;
			CSliderCtrl* psliderGammaBase;
			psliderGammaBase = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_GAMMABASE);
			nValue = psliderGammaBase->GetPos();

			CHAR pszTmp[256];
			sprintf(pszTmp, "%5.3f", (FLOAT)nValue / 1000.0f);
			CStatic* pstaticGammaBaseValue = (CStatic*)GetDlgItem(IDC_STATIC_GAMMABASEVALUE);
			pstaticGammaBaseValue->SetWindowText(pszTmp);
			g_nGammaBase = nValue;

//		}

		return;
			
	} else if (pScrollBar == GetDlgItem(IDC_SLIDER_CONTRAST)) {

//		if (nSBCode & (TB_BOTTOM | TB_LINEDOWN | TB_LINEUP | TB_PAGEDOWN | TB_PAGEUP | TB_THUMBTRACK | TB_TOP)) {
		
			INT nValue;
			CSliderCtrl* psliderContrast;
			psliderContrast = (CSliderCtrl*)GetDlgItem(IDC_SLIDER_CONTRAST);
			nValue = psliderContrast->GetPos();

			CHAR pszTmp[256];
			wsprintf(pszTmp, "%d", nValue);
			CStatic* pstaticContrastValue = (CStatic*)GetDlgItem(IDC_STATIC_CONTRASTVALUE);
			pstaticContrastValue->SetWindowText(pszTmp);
			g_nContrast = nValue;

//		}

		return;

	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
